//
// Plaintext.cc
//
// Implementation of Plaintext
//
// $Log$
//
#if RELEASE
static char RCSid[] = "$Id$";
#endif

#include "Plaintext.h"
#include "htdig.h"
#include <String.h>
#include <ctype.h>


//*****************************************************************************
// Plaintext::Plaintext()
//
Plaintext::Plaintext()
{
}


//*****************************************************************************
// Plaintext::~Plaintext()
//
Plaintext::~Plaintext()
{
}


//*****************************************************************************
// void Plaintext::parse(Retriever &retriever)
//
void
Plaintext::parse(Retriever &retriever)
{
    if (contents == 0 || contents->length() == 0)
		return;

    char	*position = contents->get();
    char	*start = position;
    int		offset = 0;
    int		in_space = 0;
    String	word;
    String	head;

    while (*position)
    {
		offset = position - start;
		word = 0;

		if (isalnum(*position))
		{
			//
			// Start of a word.  Try to find the whole thing
			//
			in_space = 0;
			while (isalnum(*position) || strchr(valid_punctuation, *position))
			{
				word << *position;
				position++;
			}

			if (head.length() < max_head_length)
			{
				head << word;
			}

			if (word.length() > 2)
			{
				word.lowercase();
				word.remove(valid_punctuation);
				if (word.length() > 2)
				{
					retriever.got_word(word,
									   int(offset * 1000 / contents->length()),
									   0);
				}
			}
		}
		
		if (head.length() < max_head_length)
		{
			//
			// Characters that are not part of a word
			//
			if (isspace(*position))
			{
				//
				// Reduce all multiple whitespace to a single space
				//
				if (!in_space)
				{
					head << ' ';
				}
				in_space = 1;
			}
			else
			{
				//
				// Non whitespace
				//
				head << *position;
				in_space = 0;
			}
		}
		position++;
    }
    retriever.got_head(head);
}


